// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SendMail.pas' rev: 3.00

#ifndef SendMailHPP
#define SendMailHPP
#include <smThread.hpp>
#include <TextTemplateConverter.hpp>
#include <WinSock.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Sendmail
{
//-- type declarations -------------------------------------------------------
enum TSMTPPriority { mpHighest, mpHigh, mpNormal, mpLow, mpLowest };

enum TSMTPAttachType { atNormal, atEmbedded };

enum TSMTPContentType { ctPlainText, ctHTML };

typedef void __fastcall (__closure *TSMTPCantAttachEvent)(System::TObject* Sender, const System::AnsiString 
	FileName);

typedef void __fastcall (__closure *TSMTPProgressEvent)(System::TObject* Sender, int MessageSize, int 
	BytesSent, Byte PercentsDone);

typedef void __fastcall (__closure *TSMTPResponseEvent)(System::TObject* Sender, int Code, const System::AnsiString 
	Response);

class DELPHICLASS TSocketHelper;
class PASCALIMPLEMENTATION TSocketHelper : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FSock;
	bool __fastcall GetIsActive(void);
	
public:
	__fastcall virtual ~TSocketHelper(void);
	virtual bool __fastcall Connect(const System::AnsiString Host, int Port);
	void __fastcall Disconnect(void);
	int __fastcall Send(void *Buf, int Len);
	bool __fastcall SendStr(System::AnsiString Str);
	int __fastcall Receive(void *Buf, int Len);
	bool __fastcall ReceiveStr(System::AnsiString &Str, int ExpectedSize);
	int __fastcall ReceiveResponse(System::AnsiString &Str, int ExpectedSize);
	__property int Sock = {read=FSock, nodefault};
	__property bool IsActive = {read=GetIsActive, nodefault};
public:
	/* TObject.Create */ __fastcall TSocketHelper(void) : System::TObject() { }
	
};

class DELPHICLASS TSMTPData;
class PASCALIMPLEMENTATION TSMTPData : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TSocketHelper* SockHelper;
	Classes::TMemoryStream* Stream;
	int ResponseCode;
	System::AnsiString ResponseStr;
	
public:
	__fastcall TSMTPData(void);
	__fastcall virtual ~TSMTPData(void);
};

class DELPHICLASS TSendMailAuthentication;
class PASCALIMPLEMENTATION TSendMailAuthentication : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	System::AnsiString FUsername;
	System::AnsiString FPassword;
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property System::AnsiString Username = {read=FUsername, write=FUsername};
	__property System::AnsiString Password = {read=FPassword, write=FPassword};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSendMailAuthentication(void) { }
	
public:
	/* TObject.Create */ __fastcall TSendMailAuthentication(void) : Classes::TPersistent() { }
	
};

class DELPHICLASS TSendMail;
class PASCALIMPLEMENTATION TSendMail : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TSendMailAuthentication* FAuthentication;
	System::AnsiString FSMTPHost;
	int FSMTPPort;
	TSMTPContentType FMsgContentType;
	System::AnsiString FMsgContentCharset;
	System::AnsiString FMsgSubject;
	System::AnsiString FMsgBody;
	System::TDateTime FMsgDateTime;
	TSMTPPriority FMsgPriority;
	Texttemplateconverter::TTextTemplateConverter* FTemplateConverter;
	bool FThreaded;
	System::AnsiString FAgent;
	System::AnsiString FFromAddress;
	System::AnsiString FFromName;
	System::AnsiString FFromOrganization;
	System::AnsiString FTo;
	System::AnsiString FToCC;
	System::AnsiString FToBCC;
	System::AnsiString FReplyTo;
	Classes::TStrings* FAddHeaders;
	Classes::TStrings* FAttach;
	TSMTPAttachType FAttachType;
	TThreadPriority FThreadPriority;
	bool FWaitThread;
	int FWaitTimeout;
	TSMTPProgressEvent FOnProgress;
	TSMTPResponseEvent FOnResponse;
	Classes::TNotifyEvent FOnSuccess;
	Classes::TNotifyEvent FOnAborted;
	Classes::TNotifyEvent FOnAnyError;
	TSMTPCantAttachEvent FOnCantAttach;
	Classes::TNotifyEvent FOnConnLost;
	Classes::TNotifyEvent FOnHostUnreachable;
	TSMTPResponseEvent FOnSMTPError;
	Smthread::TsmThreadWaitTimeoutExpired FOnWaitTimeoutExpired;
	bool FBusy;
	bool FRealBusy;
	Smthread::TCustomThread* FThread;
	TSMTPData* FActiveSMTPData;
	int CantAttachFileIndex;
	void __fastcall SetAddHeaders(Classes::TStrings* Value);
	void __fastcall SetAttach(Classes::TStrings* Value);
	void __fastcall SetTemplateConverter(Texttemplateconverter::TTextTemplateConverter* Value);
	bool __fastcall GetThreadBusy(void);
	bool __fastcall IsNotLocalHost(void);
	bool __fastcall IsNotDefaultContentCharset(void);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* aComponent, Classes::TOperation aOperation
		);
	void __fastcall ProduceMessage(const Classes::TStream* Stream, bool ToFile, bool Unsent);
	void __fastcall SendMessage(void);
	void __fastcall ReleaseSMTPStream(void);
	void __fastcall ThreadExecute(System::TObject* Sender);
	void __fastcall ThreadException(System::TObject* Sender);
	void __fastcall ThreadTerminate(System::TObject* Sender);
	void __fastcall ThreadWaitTimeoutExpired(System::TObject* Sender, bool &TerminateThread);
	void __fastcall DoHostUnreachable(void);
	void __fastcall DoSuccess(void);
	void __fastcall DoSMTPResponse(int ResponseCode, const System::AnsiString ResponseStr);
	void __fastcall DoSMTPError(int ErrorCode, const System::AnsiString ErrorStr);
	void __fastcall DoProgress(Classes::TMemoryStream* Stream);
	void __fastcall DoConnLost(void);
	void __fastcall SyncCantAttach(void);
	void __fastcall SyncHostUnreachable(void);
	void __fastcall SyncSuccess(void);
	void __fastcall SyncSMTPResponse(void);
	void __fastcall SyncSMTPError(void);
	void __fastcall SyncProgress(void);
	void __fastcall SyncConnLost(void);
	
public:
	__fastcall virtual TSendMail(Classes::TComponent* aOwner);
	__fastcall virtual ~TSendMail(void);
	bool __fastcall Send(void);
	bool __fastcall SaveToFile(const System::AnsiString FileName, bool Unsent);
	void __fastcall Abort(bool HardTerminate);
	__property bool Busy = {read=FBusy, nodefault};
	__property bool ThreadBusy = {read=GetThreadBusy, nodefault};
	__property Smthread::TCustomThread* Thread = {read=FThread};
	
__published:
	__property TSendMailAuthentication* Authentication = {read=FAuthentication, write=FAuthentication};
		
	__property System::AnsiString SMTPHost = {read=FSMTPHost, write=FSMTPHost, stored=IsNotLocalHost};
	__property int SMTPPort = {read=FSMTPPort, write=FSMTPPort, default=25};
	__property System::AnsiString MsgContentCharset = {read=FMsgContentCharset, write=FMsgContentCharset
		, stored=IsNotDefaultContentCharset};
	__property TSMTPContentType MsgContentType = {read=FMsgContentType, write=FMsgContentType, default=0
		};
	__property System::TDateTime MsgDateTime = {read=FMsgDateTime, write=FMsgDateTime};
	__property System::AnsiString MsgSubject = {read=FMsgSubject, write=FMsgSubject};
	__property System::AnsiString MsgBody = {read=FMsgBody, write=FMsgBody};
	__property TSMTPPriority MsgPriority = {read=FMsgPriority, write=FMsgPriority, default=2};
	__property System::AnsiString Agent = {read=FAgent, write=FAgent};
	__property Classes::TStrings* AddHeaders = {read=FAddHeaders, write=SetAddHeaders};
	__property Classes::TStrings* Attach = {read=FAttach, write=SetAttach};
	__property TSMTPAttachType AttachType = {read=FAttachType, write=FAttachType, default=0};
	__property System::AnsiString FromAddress = {read=FFromAddress, write=FFromAddress};
	__property System::AnsiString FromName = {read=FFromName, write=FFromName};
	__property System::AnsiString FromOrganization = {read=FFromOrganization, write=FFromOrganization};
		
	__property System::AnsiString ToAddr = {read=FTo, write=FTo};
	__property System::AnsiString ToCC = {read=FToCC, write=FToCC};
	__property System::AnsiString ToBCC = {read=FToBCC, write=FToBCC};
	__property System::AnsiString ReplyTo = {read=FReplyTo, write=FReplyTo};
	__property Texttemplateconverter::TTextTemplateConverter* TemplateConverter = {read=FTemplateConverter
		, write=SetTemplateConverter};
	__property bool Threaded = {read=FThreaded, write=FThreaded, default=1};
	__property Classes::TThreadPriority ThreadPriority = {read=FThreadPriority, write=FThreadPriority, 
		default=3};
	__property bool WaitThread = {read=FWaitThread, write=FWaitThread, default=0};
	__property int WaitTimeout = {read=FWaitTimeout, write=FWaitTimeout, default=0};
	__property TSMTPProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
	__property TSMTPResponseEvent OnResponse = {read=FOnResponse, write=FOnResponse};
	__property Classes::TNotifyEvent OnSuccess = {read=FOnSuccess, write=FOnSuccess};
	__property Classes::TNotifyEvent OnAborted = {read=FOnAborted, write=FOnAborted};
	__property Classes::TNotifyEvent OnAnyError = {read=FOnAnyError, write=FOnAnyError};
	__property TSMTPCantAttachEvent OnCantAttach = {read=FOnCantAttach, write=FOnCantAttach};
	__property Classes::TNotifyEvent OnConnLost = {read=FOnConnLost, write=FOnConnLost};
	__property Classes::TNotifyEvent OnHostUnreachable = {read=FOnHostUnreachable, write=FOnHostUnreachable
		};
	__property TSMTPResponseEvent OnSMTPError = {read=FOnSMTPError, write=FOnSMTPError};
	__property Smthread::TsmThreadWaitTimeoutExpired OnWaitTimeoutExpired = {read=FOnWaitTimeoutExpired
		, write=FOnWaitTimeoutExpired};
};

//-- var, const, procedure ---------------------------------------------------
#define LOCALHOST_STR "localhost"
#define DEF_CONTENT_CHARSET "iso-8859-1"
extern PACKAGE bool __fastcall QuickSendMail(const System::AnsiString FromAddr, const System::AnsiString 
	FromName, const System::AnsiString ToAddr, const System::AnsiString ToName, const System::AnsiString 
	Subject, const System::AnsiString Body, const System::AnsiString SMTPHost, Word SMTPPort, TSMTPContentType 
	ContentType, TSMTPPriority Priority, const System::AnsiString ContentCharset, bool RunInSeparateThread
	);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Sendmail */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sendmail;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SendMail
